﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

/*
 * Esta é a classe principal da DLL utilizada para enviar/receber informações da ITSCAM e deve ser adicionada ao seu projeto.
 * Contém todas as chamadas de funções mais atuais que compõe a biblioteca itscam.dll
 * Antes de adicionar qualquer outra função neste arquivo, consulte o suporte técnico da PUMATRONIX
 * O arquivo "itscam.dll" deve estar localizado no diretório do seu projeto, tipicamente ...\[Nome do Projeto]\[Nome do Projeto]\
 * Não se esqueça de alterar o nome do NAMESPACE para o mesmo utilizado no seu projeto!
 * 
 * Última atualização: 25/02/2015
*/

// ALTERAR O NAMESPACE, CASO UTILIZADO EM OUTRO PROJETO! (mesmo do Program.cs, tipicamente)
namespace Pumatronix_Sample
{
    class ItsCamDLL
    {
        public const string _dllLocation = "itscam.dll";
        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int criarConexaoItscam300(char[] ip);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int fecharConexaoItscam300(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leRealceBorda(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leVersaoFirmware(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leHdr(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leTipoShutter(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leShutterFixo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leShutterMaximo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leTipoGanho(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGanhoFixo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGanhoMaximo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leModoTeste(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leNivelDesejado(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorNivel(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorGanho(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorShutter(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leSituacaoDayNight(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leFormatoFotoIO(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leQualidadeFotoIO(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int lePesos(int id, int[] pesos);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorEntrada(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leRotacao(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leAutoIris(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leModoDayNight(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leModoOCR(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leRevisaoFirmware(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leTipoFlash(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leTrigger(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leTipoSaida(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorSaida(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leDelay(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leStatus(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leIp(int id, StringBuilder ip);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leMascaraRede(int id, StringBuilder mascara);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGateway(int id, StringBuilder gateway);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leMac(int id, StringBuilder mac);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int lePorcentagemSegundoDisparo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leNumeroFotos(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leNumeroFotosIO(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leSaturacao(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leBrilho(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leContraste(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGamma(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leSombra(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leModelo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leBalancoBranco(int id, int[] bb);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leFotoColorida(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGanhoAlternativo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorGanhoAlternativo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGammaAlternativo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorGammaAlternativo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leBalancoBrancoAlternativo(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leValorBalancoBrancoAlternativo(int id, int[] bb);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leBalancoBrancoAtual(int id, int[] bb);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leDelayCapturaDay(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leDelayCapturaNight(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int lePosicaoZoom(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int lePosicaoFoco(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leDataAtual(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leHoraAtual(int id);
        
        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGanhoSegundaFotoLuzVisivel(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leGanhoSegundaFotoLuzInfravermelha(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leTempoEntreTriggers(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int leIntervaloTriggersPeriodicos(int id);        

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaNivelDesejado(int id, int nivel);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaRotacao(int id, int rotacao180);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaValorSaida(int id, int saida);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaHdr(int id, int hdr);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaDelay(int id, int delay);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaShutterFixo(int id, int shutter);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaShutterMaximo(int id, int shutter);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGanhoFixo(int id, int ganho);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGanhoMaximo(int id, int ganho);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaQualidadeFotoIO(int id, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaFlash(int id, int flash);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaTrigger(int id, int trigger);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaTipoSaida(int id, int saida);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaIp(int id, char[] ip);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaMascaraRede(int id, char[] mascara);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGateway(int id, char[] gateway);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaTipoShutter(int id, int tipo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaTipoGanho(int id, int automatico);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaModoTeste(int id, int teste);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaFormatoFotoIO(int id, int formato);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaLenteAutoIris(int id, int autoiris);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaModoOCR(int id, int ocr);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaModoDayNight(int id, int daynight);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaPesos(int id, int[] pesos);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaDeadPixels(int id, int[] pixels);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaPadrao(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int reinicializaItscam(int id);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaNumeroFotos(int id, int num);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaPorcentagemSegundoDisparo(int id, int porcentagem);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaNumeroFotosIO(int id, int num);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaSaturacao(int id, int saturacao);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaBrilho(int id, int brilho);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaContraste(int id, int contraste);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGamma(int id, int gamma);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaBalancoBranco(int id, int[] bb);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaRealceBorda(int id, int borda);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaFotoColorida(int id, int cor);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGanhoAlternativo(int id, int tipo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaValorGanhoAlternativo(int id, int ganho);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGammaAlternativo(int id, int tipo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaValorGammaAlternativo(int id, int gamma);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaBalancoBrancoAlternativo(int id, int tipo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaValorBalancoBrancoAlternativo(int id, int[] bb);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaFoco(int id, int foco);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaSombra(int id, int sombra);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaZoom(int id, int zoom);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaTimeoutIO(int id, int sec);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaDelayCapturaDay(int id, int delay);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaDelayCapturaNight(int id, int delay);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaPosicaoZoom(int id, int zoom);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaPosicaoFoco(int id, int foco);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaFocoDayNight(int id, int daynight);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaMac(int id, char[] mac);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaDataAtual(int id, int data);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaHoraAtual(int id, int hora);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGanhoSegundaFotoLuzVisivel(int id, int ganho);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaGanhoSegundaFotoLuzInfravermelha(int id, int ganho);
        
        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaTempoEntreTriggers(int id, int tempo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int setaIntervaloTriggersPeriodicos(int id, int tempo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaFoto(int id, byte[] buf, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaQuadroVideo(int id, byte[] buf, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaMultiplasFotos(int id, char[] buf, int nfotos, int[] tamanho, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaMultiplasFotosSemEspera(int id, int nfotos, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaFotoId(int id, int slot, int idFoto, char[] buf, int[] tempo);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaMultiplasFotosIOSemEspera(int id, int nfotos, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarFoto(int id, char[] arquivo,int formato,int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarMultiplasFotos(int id, string[] filename, int nFotos, int[] tamFotos, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaFotoIO(int id, byte[] foto, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaMultiplasFotosIO(int id, IntPtr[] foto,int nFotos,byte[] tamFotos,int formato,int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarFotoIO(int id, char[] arquivo,int formato,int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarMultiplasFotosIO(int id, String[] filename, int nFotos, int[] tamFotos, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarFotoOcr(int id, char[] diretorio, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarFotoOcrIO(int id, char[] diretorio, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int atualizarFirmware(int id, byte[] firmware, int tamanho);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int atualizarFirmwareSenha(int id, byte[] firmware, int tamanho, int senha);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int ocrJPEG(int id, byte[] buf, StringBuilder placa);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarMultiplasFotosOcr(int id, string diretorio, int nFotos, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarMultiplasFotosOcrIO(int id, string diretorio, int nFotos, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarMultiplasFotosOcrIO(int id);
        
        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int requisitaFotoTriggerContinuo(int id, byte[] buf, int formato, int qualidade);

        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarFotoTriggerContinuo(int id, char[] arquivo, int formato, int qualidade);
        
        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern int salvarFotoOcrTriggerContinuo(int id, string diretorio, int qualidade);
        
        [DllImport(_dllLocation, CallingConvention = CallingConvention.Cdecl)]
        public static extern void broadcast(Byte[] lista, int tamanhoLista);
    }
}
