/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package javaapplication8;
import java.util.ArrayList;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.Semaphore;
import java.nio.channels.SocketChannel;
import java.nio.ByteBuffer;
import java.net.InetSocketAddress;
import java.util.concurrent.TimeUnit;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageDecoder;
/**
 *
 * @author Antonio
 */

public class Itscam extends Thread{

    public class FotoPlaca{
        public String placa;
        public int[] rgb;
    }

    public class FotoTempo{
        public int tempo;
        public ByteBuffer fotos[];
    }
    
    private class SyncArrayListRecebeDados{
        private ArrayList<RecebeDados> list;
        private Semaphore semList;
        public SyncArrayListRecebeDados(ArrayList l){
            semList = new Semaphore(1);
            list = l;
        }
        public RecebeDados encontre(byte b){
            RecebeDados config = null;
            try{
                semList.acquire();
            }
            catch(Exception e){
                return config;
            }
            for(int k=0;k<list.size();k++){
                if(list.get(k).verifica(b)){
                    config = list.get(k);
                    break;
                }
            }
            semList.release();
            return config;
        }
        public void add(RecebeDados rd){
            try{
                semList.acquire();
            }
            catch(Exception e){
                return;
            }
            list.add(rd);
            semList.release();
        }
        public void remove(RecebeDados rd){
            try{
                semList.acquire();
            }
            catch(Exception e){
                return;
            }
            list.remove(rd);
            semList.release();
        }
    }
    private class SyncArrayListPacoteFotos{
        private ArrayBlockingQueue<PacoteFotos> list;
        public SyncArrayListPacoteFotos(){
            list = new ArrayBlockingQueue(10);
        }
        public PacoteFotos encontre(int timeout){
            PacoteFotos config = null;
            try{
                config = list.poll(timeout, TimeUnit.SECONDS);
                list.remove(config);
            }
            catch(Exception e){
                
            }
            return config;
        }
        public void add(PacoteFotos rd){
            list.add(rd);
        }
        public boolean remove(PacoteFotos rd){
            boolean r;
            r = list.remove(rd);
            return r;
        }
    }

    public class PacoteFotos{
        private int tamanhoPacote;
        private ByteBuffer[] bb;
        private int tempo;
        private Semaphore[] semList;
        private int[] indices;
        private int indice;
        private PacoteFotos(int t){
            tamanhoPacote = t;
            indices = new int[t];
            semList = new Semaphore[t];
            indices[0] = 0;
            indice = 0;
            bb = new ByteBuffer[t];
            for(int i=0;i<t;i++){
                semList[i] = new Semaphore(1);
                try{
                    semList[i].acquire();
                }
                catch(Exception e){
                    return;
                }
            }
        }
        private void tempoLaco(int t){
            tempo = t;
        }
        private int preenche(ByteBuffer b, int from){
            int y = b.position() - from;
            if(y>bb[indice].remaining()) y = bb[indice].remaining();
            bb[indice].put(b.array(),from,y);
            if(bb[indice].position()==bb[indice].capacity()){
                semList[indice].release();
                indice++;
            }
            return y;
        }
        private void tamanho(int len){
            bb[indice] = ByteBuffer.allocate(len);
            indices[indice] = bb[indice].position();
        }
        public FotoTempo requisitaFotoTempo(int i){
            if(i<0 || i>=tamanhoPacote) return null;
            FotoTempo ft = new FotoTempo();
            ft.tempo = tempo;
            ft.fotos = new ByteBuffer[1];
            try{
                semList[i].acquire();
            }
            catch(Exception e){
                return null;
            }
            ft.fotos[0] = bb[i];
            semList[i].release();
            return ft;
        }
        public int numeroFotos(){
            return tamanhoPacote;
        }
        private FotoTempo requisitaFotoTempo(){
            FotoTempo ft = new FotoTempo();
            ft.fotos = new ByteBuffer[tamanhoPacote];
            try{
                semList[tamanhoPacote-1].acquire();
            }
            catch(Exception e){
                return null;
            }
            System.arraycopy(bb,0,ft.fotos,0,tamanhoPacote);
            semList[tamanhoPacote-1].release();
            ft.tempo = tempo;
            return ft;
        }
        private void clear(){
            for(int i=0;i<tamanhoPacote;i++)
                bb[i].clear();
        }
    }

    private class RecebeDados{
        private byte cfg;
        private ByteBuffer bb;
        private boolean filled;
        private ArrayBlockingQueue<ByteBuffer> array;
        private RecebeDados(byte config, int len){
            cfg = config;
            filled = false;
            bb = ByteBuffer.allocate(len);
            array = new ArrayBlockingQueue(1);
        }
        private RecebeDados(byte config){
            cfg = config;
            filled = false;
            bb = null;
            array = new ArrayBlockingQueue(1);
        }
        private void tamanho(int len){
            if(bb == null) bb = ByteBuffer.allocate(len);
            else{
                ByteBuffer x = ByteBuffer.allocate(len+bb.position());
                x.put(bb.array(),0,bb.position());
                bb = x;
            }
            filled = false;
        }
        private boolean verifica(byte config){
            return (cfg==config);
        }
        private void preenche(byte b){
            bb.put(b);
            if(bb.position()==bb.capacity()){
                array.offer(bb);
                filled = true;
            }
        }
        private int preenche(ByteBuffer b, int from){
            int y = b.position() - from;
            if(y>bb.remaining()) y = bb.remaining();
            bb.put(b.array(),from,y);
            if(bb.position()==bb.capacity()){
                array.offer(bb);
                filled = true;
            }
            return y;
        }
        private boolean preenchido(){
            return filled;
        }
    }

    public static final int ERRO_CONEXAO = -1;
    public static final int ERRO_TIMEOUT = -2;
    public static final int ERRO_VALOR = -3;
    public static final int ERRO_SEMAFORO = -4;

    public static final int SHUTTER_FIXO = 0;
    public static final int SHUTTER_AUTO = 1;
    public static final int SHUT_FIXODAY_AUTONIGHT = 0x02;

    public static final int GANHO_FIXO = 0;
    public static final int GANHO_AUTO = 1;
    public static final int FOTO_BMP = 0;
    public static final int FOTO_JPEG = 1;
    public static final int FOTO_BMP24 = 6;
    public static final int FOTO_RAW = 8;
    public static final int FOTO_YUV = 10;

    public static final int FLASH_DESAT = 0x01;
    public static final int FLASH_UNICO = 0x02;
    public static final int FLASH_CONTINUO = 0x03;
    public static final int FLASH_DELAY = 0x04;
    public static final int FLASH_AUTO_UNICO = 0x05;
    public static final int FLASH_AUTO_DELAY =  0x06;

    public static final int TRIG_REDE = 0x01;
    public static final int TRIG_IO_RISE = 0x02;
    public static final int TRIG_IO_FALL = 0x03;
    public static final int TRIG_IO_BOTH = 0x04;
    public static final int TRIG_APROX = 0x05;
    public static final int TRIG_AFAST_FC = 0x06;
    public static final int TRIG_AFAST_AB = 0x07;

    public static final int SAIDA_FLASH = 0x01;
    public static final int SAIDA_IO = 0x02;

    public static final int SAIDA_DESACIONADA = 0x00;
    public static final int SAIDA_ACIONADA = 0x01;

    public static final int HDR_NORMAL = 0x00;
    public static final int HDR_ATIVO = 0x01;

    public static final int BORDA_DESATIVADA = 0x00;
    public static final int BORDA_FILTRO1 = 0x01;
    public static final int BORDA_FILTRO2 = 0x02;
    public static final int BORDA_FILTRO2_SLOPE1 = 0x03;

    public static final int TESTE_NORMAL = 0x00;
    public static final int TESTE_VERT = 0x01;
    public static final int TESTE_HORIZ = 0x02;
    public static final int TESTE_DIAG = 0x03;

    public static final int DAYNIGHT_AUTO = 0x00;
    public static final int DAYNIGHT_DAY = 0x01;
    public static final int DAYNIGHT_NIGHT = 0x02;

    public static final int ALTERNATIVO_DESABILITADO = 0x00;
    public static final int ALTERNATIVO_DAY = 0x01;
    public static final int ALTERNATIVO_NIGHT = 0x02;

    private static final byte CABECALHO = 0xAA-256;
    private static final byte FOTO = 0x02;
    private static final byte VIDEO = 0x01;
    private static final byte FOTO_IO = 0x03;
    private static final byte INICIO_PACOTE = 0x04;
    private static final byte ENVELOPE = 0x05;
    private static final byte TEMPO_LACO = 0x09;
    private static final byte SETA_TEMPO_TRIGGER = 0x1B;
    private static final byte REQ_TEMPO_TRIGGER	= 0x1C;
    private static final byte REQ_CONF_GER  = 0x10;
    private static final byte SETA_FLASH    = 0x12;
    private static final byte SETA_TRIGGER  = 0x13;
    private static final byte SETA_TIPO_SAIDA = 0x14;
    private static final byte SETA_SAIDA    = 0x15;
    private static final byte SETA_DEFAULT = 0x17;
    private static final byte SETA_DELAY = 0x18;

    //Configurações de Rede
    private static final byte REQ_CONF_REDE = 0x20;
    private static final byte SETA_IP       = 0x21;
    private static final byte SETA_MASCARA  = 0x22;
    private static final byte SETA_GATEWAY  = 0x23;
    //Configurações de Imagem
    private static final byte REQ_CONF_IMAGEM = 0x30;
    private static final byte SETA_HDR      = 0x33;
    private static final byte SETA_TIPO_SHUT = 0x34;
    private static final byte SETA_SHUT     = 0x35;
    private static final byte SETA_SHUT_MAX = 0x36;
    private static final byte SETA_TIPO_GANHO = 0x39;
    private static final byte SETA_GANHO    = 0x3A;
    private static final byte SETA_GANHO_MAX = 0x3B;
    private static final byte SETA_MODO_TESTE = 0x3C;
    private static final byte SETA_NIVEL_IMG = 0x3D;
    private static final byte SETA_VALOR_GANHO_DIF = 0x3F;
    private static final byte SETA_TIPO_GANHO_DIF = 0x40;
    private static final byte SETA_FORMATO_FOTO_IO = 0x44;
    private static final byte SETA_QLIDADE_FOTO_IO = 0x45;
    private static final byte SETA_NUMERO_FOTOS = 0x46;
    private static final byte SETA_NUMERO_FOTOS_IO = 0x47;
    private static final byte REQ_NUMERO_FOTOS = 0x48;
    private static final byte SETA_ROTACAO = 0x4C;
    private static final byte REQ_ROTACAO = 0x4D;
    private static final byte SETA_PESOS = 0x4E;
    private static final byte REQ_PESOS = 0x4F;
    private static final byte SETA_SATURACAO = 0x56;
    private static final byte REQ_SATURACAO = 0x57;
    private static final byte SETA_WHITE_BALANCE = 0x58;
    private static final byte REQ_WHITE_BALANCE = 0x59;
    private static final byte SETA_GAMMA = 0x5A;
    private static final byte REQ_GAMMA = 0x5B;
    private static final byte SETA_FOCO = 0x5E;
    private static final byte SETA_BORDAS = 0x61;
    private static final byte REQ_BORDAS = 0x62;
    private static final byte SETA_FOTO_COLORIDA = 0x63;
    private static final byte REQ_FOTO_COLORIDA = 0x64;
    private static final byte SETA_SOMBRA = 0x65;
    private static final byte REQ_SOMBRA = 0x66;
    private static final byte SETA_GAMMA_DIF = 0x67;
    private static final byte REQ_GAMMA_DIF = 0x68;
    private static final byte SETA_WB_DIF = 0x69;
    private static final byte REQ_WB_DIF = 0x6A;
    private static final byte REQ_WB_ATUAL = 0x6B;
    private static final byte SETA_SEGUNDO_DISPARO = 0x6C;
    private static final byte REQ_SEGUNDO_DISPARO = 0x6D;
    private static final byte SETA_ZOOM = 0x6E;
    private static final byte SETA_FOCO_DAY_NIGHT = 0x6F;
    private static final byte SETA_DELAY_DAY = 0x70;
    private static final byte REQ_DELAY_DAY = 0x71;
    private static final byte SETA_DELAY_NIGHT = 0x72;
    private static final byte REQ_DELAY_NIGHT = 0x73;
    private static final byte SETA_POSICAO_ZOOM = 0x76;
    private static final byte REQ_POSICAO_ZOOM = 0x77;
    private static final byte SETA_POSICAO_FOCO = 0x78;
    private static final byte REQ_POSICAO_FOCO = 0x79;
    private static final byte SETA_NIVEL_AUTOMATICO = 0x74;
    private static final byte REQ_NIVEL_AUTOMATICO = 0x75;
    private static final byte SETA_GANHO_VISIVEL = 0x7A;
    private static final byte REQ_GANHO_VISIVEL = 0x7B;
    private static final byte SETA_GANHO_IR = 0x7C;
    private static final byte REQ_GANHO_IR = 0x7D;
    private static final byte SETA_ZOOM_FOCO = 0x7E;
    private static final byte REQ_ZOOM_FOCO = 0x7F;
    private static final byte SETA_LENTE_AUTO_IRIS = 0x80-256;
    private static final byte REQ_LENTE_AUTO_IRIS = 0x81-256;
    private static final byte SETA_MODO_DAY_NIGHT = 0x82-256;
    private static final byte REQ_MODO_DAY_NIGHT = 0x83-256;
    private static final byte REQ_SITUACAO_DAY_NIGHT = 0x84-256;
    private static final byte SETA_MODO_OCR = 0xD2-256;
    private static final byte REQ_MODO_OCR = 0xD3-256;


    private SyncArrayListRecebeDados configs;
    private SyncArrayListPacoteFotos envelopes;
    private SocketChannel channel;
    private int crcTab[];
    private int numFotosIO;
    private int numFotos;
    private int tempoLaco;
    private boolean crcTabInit = false;
    private Semaphore sem;

    private int updateCrc(byte[] c, int numBytes){
        int tmp, short_c;
        int i,crc=0;
       
        if (!crcTabInit) initCrcTab();

        for (i = 0; i < numBytes; i++){
            short_c  = 0x00ff & c[i];
            tmp = ((crc >> 8) ^ short_c) & 0x00FF;
            crc = (crc << 8) ^ crcTab[tmp];
        }
        return crc;
    }

    private void initCrcTab(){
        crcTab = new int[256];
        int c,crc;
        for(int i=0;i<256;i++){
            c = 256*i;
            crc = 0;
            for(int j=0;j<8;j++){
                if( ((crc ^ c) & 0x8000) != 0 ){
                    crc <<= 1;
                    crc ^= 0x1021;
                }
                else{
                    crc <<= 1;
                }
                crc &= 0xFFFF;
                c <<= 1;
            }
            crcTab[i] = crc;
        }
        crcTabInit = true;
    }

    private void crc(ByteBuffer b){
        int crc = updateCrc(b.array(),b.position());
        b.put((byte)(crc & 0x00FF));
        b.put((byte)((crc & 0xFF00)>>8));
    }

    public Itscam(String ip){
        int r;
        configs = new SyncArrayListRecebeDados(new ArrayList<RecebeDados>(50));
        envelopes = new SyncArrayListPacoteFotos();
        sem = new Semaphore(1);
        r = ip.indexOf(":");
        numFotosIO = 0;
        numFotos = 0;
        try{
            if(r<0) channel = SocketChannel.open(new InetSocketAddress(ip,50000));
            else channel = SocketChannel.open(new InetSocketAddress(ip.substring(0,r),
                    Integer.valueOf(ip.substring(r+1))));
        }
        catch(Exception e){
            channel = null;
        }
    }

    private ByteBuffer aloca(int h, int len){
        ByteBuffer bb = ByteBuffer.allocate(len);
        for(int i=0;i<len;i++){
            bb.put((byte) ((h>>(8*i))&0xFF));
        }
        return bb;
    }

    public int shutterAtual(){
        return reqConfig(REQ_CONF_IMAGEM,null,13,2);
    }
    public int hdr(){
        return reqConfig(REQ_CONF_IMAGEM,null,0,1);
    }
    public int hdr(int h){
        return reqConfig(SETA_HDR,aloca(h,1),0,1);
    }
    public int tipoShutter(){
        return reqConfig(REQ_CONF_IMAGEM,null,1,1);
    }
    public int tipoShutter(int tipo){
        return reqConfig(SETA_TIPO_SHUT,aloca(tipo,1),0,1);
    }
    public int shutterFixo(){
        return reqConfig(REQ_CONF_IMAGEM,null,2,2);
    }
    public int shutterFixo(int valorShutter){
        return reqConfig(SETA_SHUT,aloca(valorShutter,2),0,1);
    }
    public int shutterMaximo(){
        return reqConfig(REQ_CONF_IMAGEM,null,4,2);
    }
    public int shutterMaximo(int valorShutter){
        return reqConfig(SETA_SHUT_MAX,aloca(valorShutter,2),0,1);
    }
    public int tipoGanho(){
        return reqConfig(REQ_CONF_IMAGEM,null,6,1);
    }
    public int tipoGanho(int tipo){
        return reqConfig(SETA_TIPO_GANHO,aloca(tipo,1),0,1);
    }
    public int ganhoFixo(){
        return reqConfig(REQ_CONF_IMAGEM,null,7,1);
    }
    public int ganhoFixo(int ganho){
        return reqConfig(SETA_GANHO,aloca(ganho,1),0,1);
    }
    public int ganhoMaximo(){
        return reqConfig(REQ_CONF_IMAGEM,null,8,1);
    }
    public int ganhoMaximo(int ganho){
        return reqConfig(SETA_GANHO_MAX,aloca(ganho,1),0,1);
    }
    public int modoTeste(){
        return reqConfig(REQ_CONF_IMAGEM,null,9,1);
    }
    public int modoTeste(int modo){
        return reqConfig(SETA_MODO_TESTE,aloca(modo,1),0,1);
    }
    public int zoom(int passo){
        if(passo<0) passo = 1000 - passo;
        return reqConfig(SETA_ZOOM,aloca(passo,2),0,1);
    }
    public int foco(int passo){
        if(passo<0) passo = 1000 - passo;
        return reqConfig(SETA_FOCO,aloca(passo,2),0,1);
    }
    public int posicaoZoom(){
        return reqConfig(REQ_POSICAO_ZOOM,null,0,4);
    }
    public int posicaoZoom(int posicao){
        return reqConfig(SETA_POSICAO_ZOOM,aloca(posicao,4),0,1);
    }
    public int posicaoFoco(int posicao){
        return reqConfig(SETA_POSICAO_FOCO,aloca(posicao,4),0,1);
    }
    public int posicaoFoco(){
        return reqConfig(REQ_POSICAO_FOCO,null,0,4);
    }
    public int focoDayNight(int daynight){
        return reqConfig(SETA_FOCO_DAY_NIGHT,aloca(daynight,1),0,1);
    }
    public int nivelDesejado(){
        return reqConfig(REQ_CONF_IMAGEM,null,10,1);
    }
    public int nivelDesejado(int nivel){
        return reqConfig(SETA_NIVEL_IMG,aloca(nivel,1),0,1);
    }
    public int nivelAtual(){
        return reqConfig(REQ_CONF_IMAGEM,null,11,1);
    }
    public int ganhoAtual(){
        return reqConfig(REQ_CONF_IMAGEM,null,12,1);
    }
    public int ganhoMaximoAlternativo(){
        return reqConfig(REQ_CONF_IMAGEM,null,15,1);
    }
    public int ganhoMaximoAlternativo(int tipo){
        return reqConfig(SETA_TIPO_GANHO_DIF,aloca(tipo,1),0,1);
    }
    public int valorGanhoMaximoAlternativo(){
        return reqConfig(REQ_CONF_IMAGEM,null,16,1);
    }
    public int valorGanhoMaximoAlternativo(int ganho){
        return reqConfig(SETA_VALOR_GANHO_DIF,aloca(ganho,1),0,1);
    }
    public int formatoTrigger(){
        return reqConfig(REQ_CONF_IMAGEM,null,17,1);
    }
    public int formatoTrigger(int formato){
        return reqConfig(SETA_FORMATO_FOTO_IO,aloca(formato,1),0,1);
    }
    public int qualidadeTrigger(){
        return reqConfig(REQ_CONF_IMAGEM,null,18,1);
    }
    public int qualidadeTrigger(int qualidade){
        return reqConfig(SETA_QLIDADE_FOTO_IO,aloca(qualidade,1),0,1);
    }
    public int versaoFirmware(){
        return reqConfig(REQ_CONF_GER,null,0,1);
    }
    public int revisaoFirmware(){
        return reqConfig(REQ_CONF_GER,null,1,1);
    }
    public int modoFlash(){
        return reqConfig(REQ_CONF_GER,null,2,1);
    }
    public int modoFlash(int modo){
        return reqConfig(SETA_FLASH,aloca(modo,1),0,1);
    }
    public int modoTrigger(){
        return reqConfig(REQ_CONF_GER,null,3,1);
    }
    public int modoTrigger(int modo){
        return reqConfig(SETA_TRIGGER,aloca(modo,1),0,1);
    }
    public int tipoSaida(){
        return reqConfig(REQ_CONF_GER,null,4,1);
    }
    public int tipoSaida(int tipo){
        return reqConfig(SETA_TIPO_SAIDA,aloca(tipo,1),0,1);
    }
    public int valorSaida(){
        return reqConfig(REQ_CONF_GER,null,5,1);
    }
    public int valorSaida(int valor){
        return reqConfig(SETA_SAIDA,aloca(valor,1),0,1);
    }
    public int valorEntradas(){
        return reqConfig(REQ_CONF_GER,null,6,1);
    }
    public int delayFlash(){
        return reqConfig(REQ_CONF_GER,null,7,2);
    }
    public int delayFlash(int delay){
        return reqConfig(SETA_DELAY,aloca(delay,2),0,1);
    }
    public int tempoEntreTriggers(){
        return reqConfig(REQ_TEMPO_TRIGGER,null,0,2);
    }
    public int tempoEntreTriggers(int tempo){
        return reqConfig(SETA_TEMPO_TRIGGER,aloca(tempo,2),0,1);
    }
    public int ocr(){
        return reqConfig(REQ_MODO_OCR,null,0,1);
    }
    public int ocr(int o){
        return reqConfig(SETA_MODO_OCR,aloca(o,1),0,1);
    }
    public int autoFoco(){
        return reqConfig(REQ_ZOOM_FOCO,null,0,1);
    }
    public int autoFoto(int af){
        return reqConfig(SETA_ZOOM_FOCO,aloca(af,1),0,1);
    }
    public int ganhoLuzVisivel(){
        return reqConfig(REQ_GANHO_VISIVEL,null,0,1);
    }
    public int ganhoLuzVisivel(int ganho){
        return reqConfig(SETA_GANHO_VISIVEL,aloca(ganho,1),0,1);
    }
    public int ganhoLuzInfravermelha(){
        return reqConfig(REQ_GANHO_IR,null,0,1);
    }
    public int ganhoLuzInfravermelha(int ganho){
        return reqConfig(SETA_GANHO_IR,aloca(ganho,1),0,1);
    }
    public int nivelAutomatico(){
        return reqConfig(REQ_NIVEL_AUTOMATICO,null,0,1);
    }
    public int nivelAutomatico(int na){
        return reqConfig(SETA_NIVEL_AUTOMATICO,aloca(na,1),0,1);
    }
    public int rotacao(){
        return reqConfig(REQ_ROTACAO,null,0,1);
    }
    public int rotacao(int r){
        return reqConfig(SETA_ROTACAO,aloca(r,1),0,1);
    }
    public int delayNight(){
        return reqConfig(REQ_DELAY_NIGHT,null,0,1);
    }
    public int delayNight(int delay){
        return reqConfig(SETA_DELAY_NIGHT,aloca(delay,1),0,1);
    }
    public int delayDay(){
        return reqConfig(REQ_DELAY_DAY,null,0,1);
    }
    public int delayDay(int delay){
        return reqConfig(SETA_DELAY_DAY,aloca(delay,1),0,1);
    }
    public int lenteAutoirs(){
        return reqConfig(REQ_LENTE_AUTO_IRIS,null,0,1);
    }
    public int lenteAutoirs(int lente){
        return reqConfig(SETA_LENTE_AUTO_IRIS,aloca(lente,1),0,1);
    }
    public int dayNight(){
        return reqConfig(REQ_MODO_DAY_NIGHT,null,0,1);
    }
    public int dayNight(int modo){
        return reqConfig(SETA_MODO_DAY_NIGHT,aloca(modo,1),0,1);
    }
    public int situacaoDayNight(){
        int r = reqConfig(REQ_SITUACAO_DAY_NIGHT,null,0,1);
        if(r<0) return r;
        else if(r == DAYNIGHT_DAY) return DAYNIGHT_DAY;
        else return DAYNIGHT_NIGHT;
    }
    public int saturacao(){
        return reqConfig(REQ_SATURACAO,null,0,1);
    }
    public int saturacao(int sat){
        int r = reqConfig(REQ_SATURACAO,null,0,3);
        r &= 0xFFFF00;
        r |= sat & 0xFF;
        return reqConfig(SETA_SATURACAO,aloca(r,3),0,1);
    }
    public int brilho(){
        return reqConfig(REQ_SATURACAO,null,1,1);
    }
    public int brilho(int bri){
        int r = reqConfig(REQ_SATURACAO,null,0,3);
        r &= 0xFF00FF;
        r |= (bri & 0xFF)<<8;
        return reqConfig(SETA_SATURACAO,aloca(r,3),0,1);
    }
    public int contraste(){
        return reqConfig(REQ_SATURACAO,null,2,1);
    }
    public int contraste(int con){
        int r = reqConfig(REQ_SATURACAO,null,0,3);
        r &= 0xFFFF;
        r |= (con & 0xFF)<<16;
        return reqConfig(SETA_SATURACAO,aloca(r,3),0,1);
    }
    public int balancoBrancoAtual(){
        return reqConfig(REQ_WB_ATUAL,null,0,3);
    }
    public int balancoBranco(){
        return reqConfig(REQ_WHITE_BALANCE,null,0,3);
    }
    public int balancoBranco(int r, int g, int b){
        return balancoBranco(r|(g<<8)|(b<<16));
    }
    public int balancoBranco(int rgb){
        return reqConfig(SETA_WHITE_BALANCE,aloca(rgb,3),0,1);
    }
    public int fotoColoridaModoNight(){
        return reqConfig(REQ_FOTO_COLORIDA,null,0,1);
    }
    public int fotoColoridaModoNight(int color){
        return reqConfig(SETA_FOTO_COLORIDA,aloca(color,1),0,1);
    }
    public int realceBordas(){
        return reqConfig(REQ_BORDAS,null,0,1);
    }
    public int realceBordas(int bordas){
        return reqConfig(SETA_BORDAS,aloca(bordas,1),0,1);
    }
    public int sombra(){
        return reqConfig(REQ_SOMBRA,null,0,1);
    }
    public int sombra(int smb){
        return reqConfig(SETA_SOMBRA,aloca(smb,1),0,1);
    }
    public int porcentagemSegundoDisparo(){
        return reqConfig(REQ_SEGUNDO_DISPARO,null,0,1);
    }
    public int porcentagemSegundoDisparo(int disp){
        return reqConfig(SETA_SEGUNDO_DISPARO,aloca(disp,1),0,1);
    }
    public int gamma(){
        return reqConfig(REQ_GAMMA,null,0,1);
    }
    public int gamma(int g){
        return reqConfig(SETA_GAMMA,aloca(g,1),0,1);
    }
    public int gammaAlternativo(){
        return reqConfig(REQ_GAMMA_DIF,null,0,1);
    }
    public int gammaAlternativo(int alt){
        int r = reqConfig(REQ_GAMMA_DIF,null,0,2);
        r &= 0xFF00;
        r |= alt & 0xFF;
        return reqConfig(SETA_GAMMA_DIF,aloca(r,2),0,1);
    }
    public int valorGammaAlternativo(){
        return reqConfig(REQ_GAMMA_DIF,null,1,1);
    }
    public int valorGammaAlternativo(int gamma){
        int r = reqConfig(REQ_GAMMA_DIF,null,0,2);
        r &= 0xFF;
        r |= (gamma & 0xFF)<<8;
        return reqConfig(SETA_GAMMA_DIF,aloca(r,2),0,1);
    }
    public int balancoBrancoAlternativo(){
        return reqConfig(REQ_WB_DIF,null,0,1);
    }
    public int balancoBrancoAlternativo(int alt){
        int r = reqConfig(REQ_WB_DIF,null,1,3);
        r = alt | (r<<8);
        return reqConfig(SETA_WB_DIF,aloca(r,4),0,1);
    }
    public int valorBalancoBrancoAlternativo(){
        return reqConfig(REQ_WB_DIF,null,1,3);
    }
    public int valorBalancoBrancoAlternativo(int rgb){
        int r = reqConfig(REQ_WB_DIF,null,0,1);
        r = r | ((rgb & 0xFFFFFF)<<8);
        return reqConfig(SETA_WB_DIF,aloca(r,4),0,1);
    }
    public int valorBalancoBrancoAlternativo(int r, int g, int b){
        int rr = reqConfig(REQ_WB_DIF,null,0,1);
        int rgb = r|(g<<8)|(b<<16);
        rr |= (rgb & 0xFFFFFF)<<8;
        return reqConfig(SETA_WB_DIF,aloca(rr,4),0,1);
    }
    public String mac(){
        int m[] = new int[6];
        String str = "";
        for(int i=0;i<6;i++){
            m[i] = reqConfig(REQ_CONF_REDE,null,i,1);
            if(m[i]<0) return "Erro: "+String.valueOf(m[i]);
            if(i==0) str = hexToStr(m[i]);
            else str += "-"+hexToStr(m[i]);
        }
        return str;
    }
    public String ip(){
        int r = reqConfig(REQ_CONF_REDE,null,6,4);
        String str = "";
        for(int i=0;i<4;i++){
            str += String.valueOf(0xFF&(r>>(8*i)));
            if(i<3) str += ".";
        }
        return str;
    }
    public int ip(String novoIp){
        ByteBuffer bb = ipToInt(novoIp);
        if(bb==null) return ERRO_VALOR;
        else return reqConfig(SETA_IP,bb,0,1);
    }
    public String mascaraRede(){
        int r = reqConfig(REQ_CONF_REDE,null,10,4);
        String str = "";
        for(int i=0;i<4;i++){
            str += String.valueOf(0xFF&(r>>(8*i)));
            if(i<3) str += ".";
        }
        return str;
    }
    public int mascaraRede(String mascara){
        ByteBuffer bb = ipToInt(mascara);
        if(bb==null) return ERRO_VALOR;
        else return reqConfig(SETA_MASCARA,bb,0,1);
    }
    public String gateway(){
        int r = reqConfig(REQ_CONF_REDE,null,14,4);
        String str = "";
        for(int i=0;i<4;i++){
            str += String.valueOf(0xFF&(r>>(8*i)));
            if(i<3) str += ".";
        }
        return str;
    }
    public int gateway(String gway){
        ByteBuffer bb = ipToInt(gway);
        if(bb==null) return ERRO_VALOR;
        else return reqConfig(SETA_GATEWAY,bb,0,1);
    }
    public int pesos(int[] p){
        ByteBuffer bb = ByteBuffer.allocate(16);
        for(int i=0;i<16;i++)
            bb.put((byte)(p[i]&15));
        return reqConfig(SETA_PESOS,bb,0,1);
    }
    public int[] pesos(){
        int a[] = new int[16];
        for(int i=0;i<16;i++)
            a[i] = reqConfig(REQ_PESOS,null,i,1);
        return a;
    }
    public int numeroFotos(){
        if(numFotos>0) return numFotos;
        return numFotos = reqConfig(REQ_NUMERO_FOTOS,null,0,1);
    }
    public int numeroFotos(int n){
        numFotos = n;
        return reqConfig(SETA_NUMERO_FOTOS,aloca(n,1),0,1);
    }
    public int numeroFotosIO(){
        if(numFotosIO>0) return numFotosIO;
        return numFotosIO = reqConfig(REQ_NUMERO_FOTOS,null,1,1);
    }
    public int numeroFotosIO(int n){
        numFotosIO = n;
        return reqConfig(SETA_NUMERO_FOTOS_IO,aloca(n,1),0,1);
    }

    private ByteBuffer ipToInt(String ip){
        int i;
        int a[], b[];
        ByteBuffer bb = ByteBuffer.allocate(4);
        a = new int[4];
        b = new int[4];
        for(i=0;i<4;i++){
            if(i==0) a[i] = ip.indexOf(".");
            else a[i] = ip.indexOf(".", a[i-1] + 1);
            if(a[i]==-1) break;
        }
        if(i!=3) return null;
        b[0] = Integer.valueOf(ip.substring(0, a[0]));
        b[1] = Integer.valueOf(ip.substring(a[0]+1, a[1]));
        b[2] = Integer.valueOf(ip.substring(a[1]+1, a[2]));
        b[3] = Integer.valueOf(ip.substring(a[2]+1));
        for(i=0;i<4;i++){
            if(b[i]<0 || b[i]>255) return null;
            if(b[i]>=128) b[i] = b[i] - 256;
            bb.put((byte)b[i]);
        }
        return bb;

    }
    private String hexToStr2(int a){
        if(a<10) return String.valueOf(a);
        else return String.valueOf((char)('A'+a-10));
    }

    private String hexToStr(int a){
        return hexToStr2(a>>4) + hexToStr2(a&15);
    }

    private int reqConfig(byte config,ByteBuffer parametros,int offset,int len){
        int size;
        int timeout;
        RecebeDados rd;
        ByteBuffer r;
        ByteBuffer b;
        switch(config){
            case REQ_POSICAO_ZOOM:
            case REQ_POSICAO_FOCO:
            case SETA_POSICAO_ZOOM:
            case SETA_POSICAO_FOCO:
            case SETA_ZOOM:
            case SETA_FOCO:
            case SETA_FOCO_DAY_NIGHT:
                timeout = 30;
                break;
            default:
                timeout = 2;
                break;
        }
        switch(config){
            case REQ_CONF_REDE:
                size = 18;
                break;
            case REQ_CONF_IMAGEM:
                size = 19;
                break;
            case REQ_CONF_GER:
                size = 9;
                break;
            case REQ_SATURACAO:
            case REQ_WHITE_BALANCE:
            case REQ_WB_ATUAL:
                size = 3;
                break;
            case REQ_GAMMA_DIF:
            case REQ_NUMERO_FOTOS:
            case REQ_TEMPO_TRIGGER:
                size = 2;
                break;
            case REQ_WB_DIF:
            case REQ_POSICAO_ZOOM:
            case REQ_POSICAO_FOCO:
                size = 4;
                break;
            case REQ_PESOS:
                size = 16;
                break;
            default:
                size = 1;
                break;
        }
        rd = new RecebeDados(config,size);
        try{
            sem.acquire();
        }
        catch(Exception e){
            return ERRO_SEMAFORO;
        }
        configs.add(rd);
        if(parametros==null) b = ByteBuffer.allocate(4);
        else b = ByteBuffer.allocate(4 + parametros.limit());
        b.put(CABECALHO);
        b.put(config);
        if(parametros!=null){
            parametros.rewind();
            b.put(parametros);
        }
        crc(b);
        b.rewind();
        try{
            channel.write(b);
        }
        catch(Exception e){
            return ERRO_CONEXAO;
        }
        try{
            sem.release();
        }
        catch(Exception e){
            return ERRO_SEMAFORO;
        }
        try{
            r = rd.array.poll(timeout, TimeUnit.SECONDS);
        }
        catch(Exception e){
            return ERRO_TIMEOUT;
        }
        if(r==null) return ERRO_TIMEOUT;
        int ret = 0;
        for(int i=0;i<len;i++){
            byte x = r.get(i+offset);
            if(x>=0) ret += ((int)x)<<(8*i);
            else ret += (256+((int)x))<<(8*i);
        }
        return ret;
    }

    public int[][] requisitaFotos(){
        ByteBuffer fotos[] = requisitaFotos(1,95);
        if(fotos==null) return null;
        int x[][] = new int[fotos.length][];
        for(int i=0;i<fotos.length;i++){
            BufferedImage mImage;
            ByteArrayInputStream s = new ByteArrayInputStream(fotos[i].array(),0,fotos[i].limit());
            JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(s);
            try{
                mImage = decoder.decodeAsBufferedImage();
            }catch(Exception e){
                return null;
            }
            x[i] = mImage.getRGB(0,0,mImage.getWidth(),mImage.getHeight(), null, 0, mImage.getWidth());
        }
        return x;
    }

    public FotoPlaca[] requisitaFotos640x480(){
        ByteBuffer ref = ByteBuffer.allocate(7);
        ref.put((byte)';');
        ref.put((byte)'P');
        ref.put((byte)'l');
        ref.put((byte)'a');
        ref.put((byte)'c');
        ref.put((byte)'a');
        ref.put((byte)'=');
        ref.rewind();
        ByteBuffer fotos[] = requisitaFotos(1,95);
        if(fotos==null) return null;
        FotoPlaca x[] = new FotoPlaca[fotos.length];
        for(int i=0;i<fotos.length;i++){
            BufferedImage mImage;
            ByteArrayInputStream s = new ByteArrayInputStream(fotos[i].array(),0,fotos[i].limit());
            JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(s);
            try{
                mImage = decoder.decodeAsBufferedImage();
            }catch(Exception e){
                return null;
            }
            x[i] = new FotoPlaca();
            x[i].placa = "NA";
            x[i].rgb = mImage.getRGB(56,0,640,480, null, 0, 640);
            for(int j=fotos[i].limit()-8;j>=0 && fotos[i].get(j)!=0xFF;j--){
                fotos[i].position(j);
                fotos[i].limit(j+7);
                if(fotos[i].compareTo(ref)==0){
                    x[i].placa = "";
                    fotos[i].limit(fotos[i].capacity());
                    for(int k=j+7;k<j+14;k++){
                        char p = (char)fotos[i].get(k);
                        if(p==';'){
                            x[i].placa = "0000000";
                            break;
                        }
                        else x[i].placa += p;
                    }
                    break;
                }
            }
        }
        return x;
    }

    public FotoPlaca[] requisitaFotos640x480IO(){
        ByteBuffer ref = ByteBuffer.allocate(7);
        ref.put((byte)';');
        ref.put((byte)'P');
        ref.put((byte)'l');
        ref.put((byte)'a');
        ref.put((byte)'c');
        ref.put((byte)'a');
        ref.put((byte)'=');
        ref.rewind();

        ByteBuffer fotos[] = requisitaFotosIO(10);
        if(fotos==null) return null;
        FotoPlaca x[] = new FotoPlaca[fotos.length];
        for(int i=0;i<fotos.length;i++){
            BufferedImage mImage;
            ByteArrayInputStream s = new ByteArrayInputStream(fotos[i].array(),0,fotos[i].limit());
            JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(s);
            try{
                mImage = decoder.decodeAsBufferedImage();
            }catch(Exception e){
                return null;
            }
            x[i] = new FotoPlaca();
            x[i].placa = "NA";
            x[i].rgb = mImage.getRGB(56,0,640,480, null, 0, 640);
            for(int j=fotos[i].limit()-8;j>=0 && fotos[i].get(j)!=0xFF;j--){
                fotos[i].position(j);
                fotos[i].limit(j+7);
                if(fotos[i].compareTo(ref)==0){
                    x[i].placa = "";
                    fotos[i].limit(fotos[i].capacity());
                    for(int k=j+7;k<j+14;k++){
                        char p = (char)fotos[i].get(k);
                        if(p==';'){
                            x[i].placa = "0000000";
                            break;
                        }
                        else x[i].placa += p;
                    }
                    break;
                }
            }
        }
        return x;
    }

    public String ocrJPEG(ByteBuffer x){
        String placa = "";
        ByteBuffer ref = ByteBuffer.allocate(7);
        ref.put((byte)';');
        ref.put((byte)'P');
        ref.put((byte)'l');
        ref.put((byte)'a');
        ref.put((byte)'c');
        ref.put((byte)'a');
        ref.put((byte)'=');
        ref.rewind();

        for(int j=x.limit()-8;j>=0 && x.get(j)!=-1;j--){
            x.position(j);
            x.limit(j+7);
            if(x.compareTo(ref)==0){
                x.limit(x.capacity());
                for(int k=j+7;k<j+14;k++){
                    char p = (char)x.get(k);
                    if(p==';'){
                        placa = "0000000";
                        break;
                    }
                    else placa += p;
                }
                break;
            }
        }
        x.limit(x.capacity());
        return placa;

    }



    public ByteBuffer[] requisitaFotos(int formato, int qualidade){
        ByteBuffer r[] = new ByteBuffer[numeroFotos()];
        RecebeDados rd[] = new RecebeDados[r.length];
        try{
            sem.acquire();
        }
        catch(Exception e){
            return null;
        }
        for(int i=0;i<r.length;i++){
            rd[i] = new RecebeDados(FOTO);
            configs.add(rd[i]);
        }
        ByteBuffer b = ByteBuffer.allocate(6);
        b.put(CABECALHO);
        b.put(FOTO);
        b.put((byte)formato);
        b.put((byte)qualidade);
        crc(b);
        b.rewind();
        try{
            channel.write(b);
            sem.release();
            for(int i=0;i<r.length;i++){
                r[i] = rd[i].array.poll(10, TimeUnit.SECONDS);
                configs.remove(rd[i]);
            }
        }
        catch(Exception e){
            return null;
        }
        return r;
    }

    public ByteBuffer requisitaVideo(int formato, int qualidade){
        RecebeDados rd = new RecebeDados(VIDEO);
        ByteBuffer r = null;
        try{
            sem.acquire();
        }
        catch(Exception e){
            return null;
        }
        configs.add(rd);
        ByteBuffer b = ByteBuffer.allocate(6);
        b.put(CABECALHO);
        b.put(VIDEO);
        b.put((byte)formato);
        b.put((byte)qualidade);
        crc(b);
        b.rewind();
        try{
            channel.write(b);
            sem.release();
            r = rd.array.poll(10, TimeUnit.SECONDS);
            configs.remove(rd);
        }
        catch(Exception e){
            return null;
        }
        return r;
    }

    public ByteBuffer[] requisitaFotosIO(int timeout){
        PacoteFotos pacote;
        pacote = envelopes.encontre(timeout);
        if(pacote==null) return null;
        FotoTempo ft;
        ft = pacote.requisitaFotoTempo();
        return ft.fotos;
    }
    public FotoTempo requisitaFotosIOtempo(int timeout){
        PacoteFotos pacote;
        pacote = envelopes.encontre(timeout);
        if(pacote==null) return null;
        FotoTempo ft;
        ft = pacote.requisitaFotoTempo();
        return ft;
    }

    public PacoteFotos requisitaFotosIOtempoAssincrono(int timeout){
        return envelopes.encontre(timeout);
    }

    public void run(){
        int read;
        ByteBuffer dst;
        RecebeDados config = null;
        int estado = 0, byteCount = 0, tempInt = 0;
        byte formato;
        int tamanhoPacote = 0, auxcrc = 0, auxcrc2;
        ByteBuffer imagem = null;
        PacoteFotos env = null;
        String mensagem = "";
        
        dst = ByteBuffer.allocate(8192);

        while(!Thread.interrupted()){
            try{
                dst.rewind();
                read = channel.read(dst);
                for(int i=0;i<read;i++){
                    switch(estado){
                        case 0:
                            if(dst.get(i)==CABECALHO) estado = -1;
                            break;
                        case -1:
                            if(dst.get(i)==FOTO){
                                if(tamanhoPacote<0) tamanhoPacote = 0;
                                if(tamanhoPacote == 0) estado = 2;
                                else estado = 3;
                            }
                            else if(dst.get(i)==VIDEO) estado = 1;
                            else if(dst.get(i)==INICIO_PACOTE) estado = 4;
                            else if(dst.get(i)==0x0A) estado = 6;
                            else if(dst.get(i)==TEMPO_LACO) estado = 5;
                            else{
                                config = configs.encontre(dst.get(i));
                                if(config!=null) estado = 100;
                            }
                            if(estado==-1) estado = 0;//nao achou nenhuma configuracao esperando
                            byteCount = 0;
                            break;
                        case 6:
                            if(byteCount==0) mensagem = "";
                            if(byteCount>=61){
                                mensagem += (char) dst.get(i);
                                System.out.println(mensagem);
                                estado = 0;
                            }
                            else mensagem += (char) dst.get(i);
                            byteCount++;
                            break;
                        case 5:
                            if(byteCount==0) tempoLaco = 0;
                            int aux = (int)dst.get(i);
                            if(aux<0) aux += 256;
                            tempoLaco += aux<<(8*byteCount);
                            byteCount++;
                            if(byteCount>=4){
                                if(env!=null) env.tempoLaco(tempoLaco);
                                estado = 0;
                            }
                            break;
                        case 4:
                            if(byteCount==0) tamanhoPacote = dst.get(i);
                            else if(byteCount==1){
                                auxcrc = dst.get(i);
                                if(auxcrc<0) auxcrc += 256;
                            }
                            else if(byteCount==2){
                                auxcrc2 = dst.get(i);
                                if(auxcrc2<0) auxcrc2 += 256;
                                auxcrc += 256*auxcrc2;
                                ByteBuffer bb = ByteBuffer.allocate(3);
                                bb.put(CABECALHO);
                                bb.put(INICIO_PACOTE);
                                bb.put((byte)tamanhoPacote);
                                if((updateCrc(bb.array(),3)&0xFFFF)!=auxcrc){
                                    tamanhoPacote = 0;
                                }
                                else{
                                    if(envelopes.remove(env))
                                        env.clear();
                                    env = new PacoteFotos(tamanhoPacote);
                                    env.tempoLaco(tempoLaco);
                                    envelopes.add(env);
                                }
                                estado = 0;
                            }
                            byteCount++;
                            break;
                        case 100:
                            if(config!=null){
                                int y = config.preenche(dst,i);
                                i += y - 1;
                                if(config.preenchido()){
                                    estado = 0;
                                    configs.remove(config);
                                    config = null;
                                }
                            }
                            break;
                        case 1:
                        case 2:
                        case 3:
                            if(byteCount==0){
                                formato = dst.get(i);
                                tempInt = 0;
                            }
                            else if(byteCount<5){
                                int ti = dst.get(i);
                                if(ti<0) ti += 256;
                                tempInt += ti<<(8*(byteCount-1));
                                if(byteCount==4){
                                    if(estado!=3){
                                        config = configs.encontre((byte)estado);
                                        if(config!=null) config.tamanho(tempInt);
                                        else imagem = ByteBuffer.allocate(tempInt);
                                    }
                                    else{
                                        env.tamanho(tempInt);
                                    }
                                }
                            }
                            else{
                                if(estado==3){
                                    int y = env.preenche(dst, i);
                                    i += y - 1;
                                    byteCount += y - 1;
                                    if(byteCount+1 >= tempInt+5){
                                        estado = 0;
                                        tamanhoPacote--;
                                    }
                                }
                                else if(config != null)
                                {
                                    int y = config.preenche(dst,i);
                                    i += y - 1;
                                    byteCount += y - 1;
                                    if(config.preenchido()){
                                        estado = 0;
                                        configs.remove(config);
                                        config = null;
                                    }
                                }
                                else if(imagem!=null){
                                    int y = dst.position() - i;
                                    if(y>imagem.remaining()) y = imagem.remaining();
                                    imagem.put(dst.array(),i,y);
                                    i += y - 1;
                                    byteCount += y - 1;
                                    if(imagem.remaining()<=0){
                                        estado = 0;
                                    }
                                }
                                else{
                                    estado = 0;
                                }
                            }
                            byteCount++;
                            break;
                        default:
                            estado = 0;
                            break;
                    }
                }
            }
            catch(Exception e){
                break;
            }
        }
    }
}
