#ifndef PROTOCOLO_H
#define PROTOCOLO_H

//Identificao (Protocolo UDP)
#define REQ_IDENT 0x00 

//Transmisso de imagem
#define VIDEO 0x01 
#define FOTO 0x02 
#define FOTO_IO 0x03
#define INICIO_PACOTE_CRC 0x04
#define TEMPO_LACO 0x09
#define MENSAGEM_TEXTO 0x0A
#define VIDEO_REDIMENSIONADO 0x0B
#define CHAVE_PUBLICA 0x0C
#define FOTO_INFO_ADIC 0x0D
#define REINICIALIZA_ITSCAM 0x0F

//Configuraes Gerais
#define REQ_CONF_GER 0x10 
#define SETA_FLASH 0x12 
#define SETA_TRIGGER 0x13 
#define SETA_TIPO_SAIDA 0x14 
#define SETA_SAIDA 0x15 
#define REQ_ENTRADA 0x16 
#define SETA_DEFAULT 0x17 
#define SETA_DELAY 0x18 
#define SETA_USER 0x19
#define SETA_TEMPO_TRIGGER 0x1B
#define REQ_TEMPO_TRIGGER 0x1C
#define REQ_MODELO 0x1D

//Configuraes de Rede
#define REQ_CONF_REDE 0x20 
#define SETA_IP 0x21 
#define SETA_MASCARA 0x22 
#define SETA_GATEWAY 0x23 
#define SETA_MAC 0x24

//Configuraes de Imagem
#define REQ_CONF_IMAGEM 0x30 
#define SETA_HDR 0x33 
#define SETA_TIPO_SHUT 0x34 
#define SETA_SHUT 0x35 
#define SETA_SHUT_MAX 0x36 
#define SETA_TIPO_GANHO 0x39 
#define SETA_GANHO 0x3A 
#define SETA_GANHO_MAX 0x3B 
#define SETA_MODO_TESTE 0x3C 
#define SETA_NIVEL_IMG 0x3D 
#define SETA_GANHO_DIF 0x3F 
#define SETA_TIPO_GANHO_DIF 0x40 
#define SETA_FORMATO_FOTO_IO 0x44 
#define SETA_QLIDADE_FOTO_IO 0x45 
#define SETA_NUMERO_FOTOS 0x46 
#define SETA_NUMERO_FOTOS_IO 0x47 
#define REQ_NUMERO_FOTOS 0x48 
#define SETA_CONTEXTO 0x49 
#define TROCA_CONTEXTO 0x4A 
#define REQ_CONTEXTO 0x4B
#define SETA_ROTACAO 0x4C
#define REQ_ROTACAO 0x4D
#define SETA_PESOS 0x4E
#define REQ_PESOS 0x4F
#define SETA_RESOLUCAO 0x51
#define REQ_SHUT 0x52
#define REQ_GANHO 0x53
#define REQ_RESOLUCAO 0x54
#define REQ_FLASH 0x55
#define SETA_SATURACAO 0x56
#define REQ_SATURACAO 0x57
#define SETA_WHITE_BALANCE 0x58
#define REQ_WHITE_BALANCE 0x59
#define SETA_GAMMA 0x5A
#define REQ_GAMMA 0x5B
#define SETA_ABERTURA 0x5C
#define REQ_ABERTURA 0x5D
#define SETA_FOCO 0x5E
#define SETA_CHROMA 0x5F
#define REQ_TEMPO_LIGADO 0x60
#define SETA_BORDAS 0x61
#define REQ_BORDAS 0x62
#define SETA_FOTO_COLORIDA 0x63
#define REQ_FOTO_COLORIDA 0x64
#define SETA_ECLIPSE 0x65
#define REQ_ECLIPSE 0x66
#define SETA_GAMMA_DIF 0x67
#define REQ_GAMMA_DIF 0x68
#define SETA_WB_DIF 0x69
#define REQ_WB_DIF 0x6A
#define REQ_WB_ATUAL 0x6B
#define SETA_SEGUNDO_DISPARO 0x6C
#define REQ_SEGUNDO_DISPARO 0x6D
#define SETA_ZOOM 0x6E
#define SETA_FOCO_DAY_NIGHT 0x6F
#define SETA_DELAY_DAY 0x70
#define REQ_DELAY_DAY 0x71
#define SETA_DELAY_NIGHT 0x72
#define REQ_DELAY_NIGHT 0x73
#define SETA_POSICAO_ZOOM 0x76
#define REQ_POSICAO_ZOOM 0x77
#define SETA_POSICAO_FOCO 0x78
#define REQ_POSICAO_FOCO 0x79
#define SETA_GANHO_VISIVEL 0x7A
#define REQ_GANHO_VISIVEL 0x7B
#define SETA_GANHO_IR 0x7C
#define REQ_GANHO_IR 0x7D
#define SETA_ZOOM_FOCO 0x7E
#define REQ_ZOOM_FOCO 0x7F
//Configuracoes de data e hora
#define SETA_DIR_IO_VIGIA 0x90
#define REQ_DIR_IO_VIGIA 0x91
#define SETA_IO_VIGIA 0x92
#define REQ_IO_VIGIA 0x93
#define SETA_DATA 0x94
#define REQ_DATA 0x95
#define SETA_HORA 0x96
#define REQ_HORA 0x97
#define SETA_MULT_SHUTTER 0x98
#define REQ_MULT_SHUTTER 0x99
#define SETA_MULT_SHUTTER_DAY 0x9A
#define REQ_MULT_SHUTTER_DAY 0x9B
#define SETA_TIPO_SERVIDOR 0x9C
#define REQ_TIPO_SERVIDOR 0x9D
#define SETA_CONFIG_SERIAL 0x9E
#define REQ_CONFIG_SERIAL 0x9F
#define SETA_PORTA_SERVIDOR 0xA2
#define REQ_PORTA_SERVIDOR 0xA3
//Limiares
#define SETA_LIMIAR_DAY_NIGHT 0xA4
#define REQ_LIMIAR_DAY_NIGHT 0xA5
#define SETA_LIMIAR_NIGHT_DAY 0xA6
#define REQ_LIMIAR_NIGHT_DAY 0xA7
#define SETA_LIMIAR_DAY_NIGHT_MOT 0xAC
#define REQ_LIMIAR_DAY_NIGHT_MOT 0xAD
#define SETA_LIMIAR_NIGHT_DAY_MOT 0xAE
#define REQ_LIMIAR_NIGHT_DAY_MOT 0xAF

//Atualizao de Firmware
#define FIRMWARE 0x50
#define FIRMWARE_TAMANHO 0xB0
#define FIRMWARE_TAMANHO_SEM_VERIFICACAO 0xB1
#define FIRMWARE_TAMANHO_16M 0xB2
//Configuracao de Auto-Iris
#define SETA_LENTE_AUTO_IRIS 0x80
#define REQ_LENTE_AUTO_IRIS 0x81
#define SETA_MODO_DAY_NIGHT 0x82
#define REQ_MODO_DAY_NIGHT 0x83
#define REQ_SITUACAO_DAY_NIGHT 0x84
#define SETA_TRIGGER_PERIODICO 0x85
#define REQ_TRIGGER_PERIODICO 0x86
#define REQ_FOCO_IR 0x87
#define SETA_TRIGGER_DIF 0x88
#define REQ_TRIGGER_DIF 0x89
#define SETA_VALOR_TRIGGER_DIF 0x8A
#define REQ_VALOR_TRIGGER_DIF 0x8B
#define SETA_OCR_DIF 0x8C
#define REQ_OCR_DIF 0x8D
#define SETA_VALOR_OCR_DIF 0x8E
#define REQ_VALOR_OCR_DIF 0x8F
//OCR
#define SETA_MODO_OCR 0xD2
#define REQ_MODO_OCR 0xD3

//Eventos
#define EVENTO_TRIGGER 0xA0

//Parmetros dos Comandos
#define FOTO_BMP 0x00 
#define FOTO_JPEG 0x01
#define FOTO_BAYER 0x02
#define FOTO_BAYER_WB 0x03 
#define FOTO_BAYER_ID 0xFF

#define FLASH_DESAT 0x01 
#define FLASH_UNICO 0x02 
#define FLASH_CONTINUO 0x03 
#define FLASH_DELAY 0x04
#define FLASH_AUTO 0x05
#define FLASH_AUTO_DELAY 0x06

#define TRIG_REDE       0x01
#define TRIG_IO_RISE    0x02
#define TRIG_IO_FALL    0x03
#define TRIG_IO_BOTH    0x04
#define TRIG_APROX		0x05
#define TRIG_AFAST1		0x06
#define TRIG_AFAST2		0x07
#define TRIG_CONTINUO	0x08
#define TRIG_PERIODICO	0x09
#define TRIG_IO_HIGH	0x0A
#define TRIG_IO_LOW		0x0B
#define TRIG_RISE_APR	0x0C

#define SETA_DEAD_PIXELS 0x1A

#define SAIDA_FLASH 0x01 
#define SAIDA_IO 0x02 

#define DESACIONADO 0x00 
#define ACIONADO 0x01 
#define HDR_NORMAL 0x00 
#define HDR_ATIVO 0x01 

#define SHUT_FIXO 0x00 
#define SHUT_AUTO 0x01 
#define SHUT_FIXODAY_AUTONIGHT 0x02

#define TIPO_GANHO_FIXO 0x00 
#define TIPO_GANHO_AUTO 0x01 

#define TESTE_NORMAL 0x00 
#define TESTE_VERT 0x01 
#define TESTE_HORIZ 0x02 
#define TESTE_DIAG 0x03 

#define GANHO_EST_FIXO 0x00 
#define GANHO_EST_AUTO 0x01

#define DAYNIGHT_AUTO 	0x00
#define DAYNIGHT_DAY 	0x01
#define DAYNIGHT_NIGHT	0x02

#define JIDOSHA_DISABLE			0
#define JIDOSHA_MODO_FAST 		1
#define JIDOSHA_MODO_NORMAL		2
#define JIDOSHA_MODO_SLOW		3
#define JIDOSHA_MODO_ULTRA_SLOW	4

enum{
	CAMERA_OK,
	INVALID_ID,
	SOCKET_CREATION_ERROR,
	UNABLE_TO_CONNECT,
	MUTEX_CREATION_ERROR,
	CREATING_THREAD,
	TIMEOUT_EXCEEDED,
	LOST_CONNECTION,
	OBJECT_DESTROYED,
	INVALID_VALUE,
	INCOMPATIBLE_VERSION,
	ENUMERATION_ERROR,
	NOT_READY,
	NOT_SAVED,
	SLOT_FULL,
};

enum{
	HDR,
	TIPO_SHUTTER,
	SHUTTER_FIXO,
	SEGUNDO_BYTE_SHUTTER_FIXO,
	SHUTTER_MAX,
	SEGUNDO_BYTE_SHUTTER_MAX,
	TIPO_GANHO,
	GANHO_FIXO,
	GANHO_MAX,
	MODO_TESTE,
	NIVEL_DESEJADO,
	NIVEL_ATUAL,
	VALOR_GANHO,
	VALOR_SHUTTER,
	SEGUNDO_BYTE_VALOR_SHUTTER,
	TIPO_GANHO_DIF,
	VALOR_GANHO_DIF,
	FORMATO_FOTO_IO,
	QUALIDADE_FOTO_IO,
	TOTAL_CONFIG_IMAGEM
};

enum{
	VERSAO,
	REVISAO,
	FLASH,
	TRIGGER,
	TIPO_SAIDA,
	SAIDA,
	ENTRADA,
	DELAY,
	SEGUNDO_BYTE_DELAY,
	TOTAL_CONFIG_GERAL
};

enum{
	REDE_MAC,
	SEGUNDO_BYTE_MAC,
	TERCEIRO_BYTE_MAC,
	QUARTO_BYTE_MAC,
	QUINTO_BYTE_MAC,
	SEXTO_BYTE_MAC,
	REDE_IP,
	SEGUNDO_BYTE_IP,
	TERCEIRO_BYTE_IP,
	QUARTO_BYTE_IP,
	REDE_MASCARA,
	SEGUNDO_BYTE_MASCARA,
	TERCEIRO_BYTE_MASCARA,
	QUARTO_BYTE_MASCARA,
	REDE_GATEWAY,
	SEGUNDO_BYTE_GATEWAY,
	TERCEIRO_BYTE_GATEWAY,
	QUARTO_BYTE_GATEWAY,
	TOTAL_CONFIG_REDE
};

enum{
	NUM_FOTOS_REDE,
	NUM_FOTOS_IO,
	TOTAL_NUM_FOTOS
};


#endif
